#ifndef _LED_																				//    
#define _LED_

#define LD_OFF	0																			// " "
#define LD_ON	1																			// " "
#define LD_SW	2																			// " " ( )

#if _LED_DATA-2

#include <avr/iom128.h>																		//  /

#ifndef F_CPU
# warning "F_CPU not defined. Frequency by default 14,7456MHz"
#define F_CPU 14745600UL																	//     (     )
#endif

#define ENABLE	1																			// ""
#define DISABLE	0																			// ""

#include <util/delay.h>																		//   

//#include "Timer2.h"																			//   - 2

// 
__flash const uint8_t ASCII[256]={
0x00,/*00h GCRAM 1*/0x01,/*01h GCRAM 2*/0x02,/*02h GCRAM 3*/0x03,/*03h GCRAM 4*/0x04,/*04h GCRAM 5*/0x05,/*05h GCRAM 6*/0x06,/*06h GCRAM 7*/0x07,/*07h GCRAM 8*/ 
0x08,/*08h GCRAM 1*/0x09,/*09h GCRAM 2*/0x0A,/*0Ah GCRAM 3*/0x0B,/*0Bh GCRAM 4*/0x0C,/*0Ch GCRAM 5*/0x0D,/*0Dh GCRAM 6*/0x0E,/*0Eh GCRAM 7*/0x0F,/*0Fh GCRAM 8*/ 
0x10,/*10h   */		0x11,/*11h   */		0x12,/*12h   */		0x13,/*13h   */	    0x14,/*14h   */     0x15,/*15h   */		0x16,/*16h   */	    0x17,/*17h   */
0x18,/*18h   */		0x19,/*19h   */		0x1A,/*1Ah   */		0x1B,/*1Bh   */	    0x1C,/*1Ch   */     0x1D,/*1Dh   */		0x1E,/*1Eh   */	    0x1F,/*1Fh   */
0x20,/*20h  */0x21,/*21h ! */		0x22,/*22h " */		0x23,/*23h # */		0x24,/*24h $ */		0x25,/*25h % */		0x26,/*26h & */		0x27,/*27h ' */
0x28,/*28h ( */		0x29,/*29h ) */		0x2A,/*2Ah * */		0x2B,/*2Bh + */		0x2C,/*2Ch , */		0x2D,/*2Dh - */		0x2E,/*2Eh . */		0x2F,/*2Fh / */
0x30,/*30h 0 */		0x31,/*31h 1 */		0x32,/*32h 2 */		0x33,/*33h 3 */		0x34,/*34h 4 */		0x35,/*35h 5 */		0x36,/*36h 6 */		0x37,/*37h 7 */
0x38,/*38h 8 */		0x39,/*39h 9 */		0x3A,/*3Ah : */		0x3B,/*3Bh ; */		0x3C,/*3Ch < */		0x3D,/*3Dh = */		0x3E,/*3Eh > */		0x3F,/*3Fh ? */
0x40,/*40h @ */		0x41,/*41h A */		0x42,/*42h B */		0x43,/*43h C */		0x44,/*44h D */		0x45,/*45h E */		0x46,/*46h F */		0x47,/*47h G */
0x48,/*48h H */		0x49,/*49h I */		0x4A,/*4Ah J */		0x4B,/*4Bh K */	    0x4C,/*4Ch L */		0x4D,/*4Dh M */		0x4E,/*4Eh N */	    0x4F,/*4Fh O */
0x50,/*50h P */		0x51,/*51h Q */		0x52,/*52h R */		0x53,/*53h S */	    0x54,/*54h T */		0x55,/*55h U */		0x56,/*56h V */	    0x57,/*57h W */
0x58,/*58h X */		0x59,/*59h Y */		0x5A,/*5Ah Z */		0x5B,/*5Bh [ */	    0x5C,/*5Ch   */		0x5D,/*5Dh ] */		0x5E,/*5Eh ^ */	    0x5F,/*5Fh _ */
0x60,/*60h ` */		0x61,/*61h a */		0x62,/*62h b */		0x63,/*63h c */	    0x64,/*64h d */		0x65,/*65h e */		0x66,/*66h f */	    0x67,/*67h g */
0x68,/*68h h */		0x69,/*69h i */		0x6A,/*6Ah j */		0x6B,/*6Bh k */	    0x6C,/*6Ch l */		0x6D,/*6Dh m */		0x6E,/*6Eh n */	    0x6F,/*6Fh o */
0x70,/*70h p */		0x71,/*71h q */		0x72,/*72h r */		0x73,/*73h s */	    0x74,/*74h t */		0x75,/*75h u */		0x76,/*76h v */	    0x77,/*77h w */
0x78,/*78h x */		0x79,/*79h y */		0x7A,/*7Ah z */		0x7B,/*7Bh   */	    0xD1,/*7Ch | */		0x7D,/*7Dh   */		0xE9,/*7Eh ~ */		0x7F,/*7Fh   */

0x80,/*80h   */		0x81,/*81h   */		0x27,/*82h , */		0x83,/*83h   */	    0x22,/*84h " */		0x85,/*85h   */		0x86,/*86h   */	    0x87,/*87h   */
0x88,/*88h   */		0x89,/*89h   */		0x8A,/*8Ah   */		0x8B,/*8Bh   */     0x8C,/*8Ch   */		0x8D,/*8Dh   */	    0x8E,/*8Eh   */		0x8F,/*8Fh   */
0x90,/*90h   */		0x60,/*91h ' */		0x61,/*92h ' */		0xCA,/*93h " */	    0xCB,/*94h " */		0xDF,/*95h . */		0x5F,/*96h _ */	    0x5F,/*97h _ */
0x98,/*98h   */		0x99,/*99h   */		0x9A,/*9Ah   */		0x9B,/*9Bh   */     0x9C,/*9Ch   */		0x9D,/*9Dh   */	    0x9E,/*9Eh   */		0x9F,/*9Fh   */
0xA0,/*A0h   */		0x8D,/*A1h   */		0xA2,/*A2h   */		0xA3,/*A3h   */	    0xA4,/*A4h   */		0xA5,/*A5h   */		0xD1,/*A6h  */	    0xFD,/*A7h  */
0xA2,/*A8h  */		0xA9,/*A9h   */		0xAA,/*AAh   */		0xCA,/*ABh " */     0xAC,/*ACh   */		0xAD,/*ADh   */	    0xAE,/*AEh   */		0xAF,/*AFh   */
0xEF,/*B0h . */	0xB1,/*B1h   */		0x49,/*B2h I */		0x69,/*B3h i */	    0x72,/*B4h r */		0xB5,/*B5h   */		0xB6,/*B6h   */	    0xB7,/*B7h   */
0xB5,/*B8h  */		0xCC,/*B9h  */		0xBA,/*BAh   */		0xCB,/*BBh " */     0xBC,/*BCh   */		0xBD,/*BDh   */	    0xBE,/*BEh   */		0xBF,/*BFh   */
0x41,/*C0h  */		0xA0,/*C1h  */		0x42,/*C2h  */		0xA1,/*C3h  */	    0xE0,/*C4h  */		0x45,/*C5h  */		0xA3,/*C6h  */	    0xA4,/*C7h  */
0xA5,/*C8h  */		0xA6,/*C9h  */		0x4B,/*CAh  */		0xA7,/*CBh  */     0x4D,/*CCh  */		0x48,/*CDh  */	    0x4F,/*CEh  */		0xA8,/*CFh  */
0x50,/*D0h  */		0x43,/*D1h  */		0x54,/*D2h  */		0xA9,/*D3h  */	    0xAA,/*D4h  */		0x58,/*D5h  */		0xE1,/*D6h  */	    0xAB,/*D7h  */
0xAC,/*D8h  */		0xE2,/*D9h  */		0xAD,/*DAh  */		0xAE,/*DBh  */     0xC4,/*DCh  */		0xAF,/*DDh  */	    0xB0,/*DEh  */		0xB1,/*DFh  */
0x61,/*E0h  */		0xB2,/*E1h  */		0xB3,/*E2h  */		0xB4,/*E3h  */	    0xE3,/*E4h  */		0x65,/*E5h  */		0xB6,/*E6h  */	    0xB7,/*E7h  */
0xB8,/*E8h  */		0xB9,/*E9h  */		0xBA,/*EAh  */		0xBB,/*EBh  */     0xBC,/*ECh  */		0xBD,/*EDh  */	    0x6F,/*EEh  */		0xBE,/*EFh  */
0x70,/*F0h  */		0x63,/*F1h  */		0xBF,/*F2h  */		0x79,/*F3h  */	    0xE4,/*F4h  */		0x78,/*F5h  */		0xE5,/*F6h  */	    0xC0,/*F7h  */
0xC1,/*F8h  */		0xE6,/*F9h  */		0xC2,/*FAh  */		0xC3,/*FBh  */	    0xC4,/*FCh  */		0xC5,/*FDh  */		0xC6,/*FEh  */	    0xC7,/*FFh  */
};


//===========        "E" =============
void _StrobE(void)
{
	PORTE|=(1<<PE6);																		// 
	_delay_us(1);																			//
	PORTE&=~(1<<PE6);																		// 
}

//==============================    ==============================
void _LED_Function_Set(void)
{
#if	_LED_DATA																				//   (     PORTA4-PORTA7)
	PORTA=0x20;																				//  (4  )
	_StrobE();																				//   ( )
	
	PORTA=0x20;																				//    (     4  )
	_StrobE();																				//  
	
	PORTA=0xA0;																				//  (2  , 5*8   ,   )
	_StrobE();																				//  
#else																						//   (     PORTF0-PORTF3)
	PORTF=0x02;																				//  (4  )
	_StrobE();																				//   ( )
	
	PORTF=0x02;																				//    (     4  )
	_StrobE();																				//  
	
	PORTF=0x0A;																				//  (2  , 5*8   ,   )
	_StrobE();																				//  
#endif
}

//============================    ==============================
//  :
//Power -     (/)
//Cursor -    (/)
//Blink -    (  DATASHEET!)

void _LED_Display_Control(uint8_t Power, uint8_t Cursor, uint8_t Blink)
{
#if	_LED_DATA																				//   (     PORTA4-PORTA7)	
	uint8_t temp=0x80;																		// 

	PORTA=0x00;																				// 
	_StrobE();																				// 
	
	if (Power) temp|=0x40;
	if (Cursor) temp|=0x20;
	if (Power) temp|=0x10;
	PORTA=temp;																				// 
	_StrobE();																				// 	
#else																						//   (     PORTF0-PORTF3)	
	uint8_t temp=0x08;																		// 

	PORTF=0x00;																				// 
	_StrobE();																				// 	
	
	if (Power) temp|=0x04;
	if (Cursor) temp|=0x02;
	if (Power) temp|=0x01;
	PORTF=temp;																				// 
	_StrobE();																				// 		
#endif	
}

//==========================     ===========================
//  :
//ID -          (0-/1-)
//S -     ( S=1  ID=0  / S=1  ID=0  ,  S=0  )

void _LED_Entry_Mode_Set(uint8_t ID, uint8_t S)
{
#if	_LED_DATA																				//   (     PORTA4-PORTA7)		
	uint8_t temp=0x40;																		// 
	
	PORTA=0x00;																				// 																				
	_StrobE();																				// 
	
	if (ID) temp|=0x20;
	if (S) temp|=0x10;
	PORTA=temp;																				// 
	_StrobE();																				// 
#else																						//   (     PORTF0-PORTF3)	
	uint8_t temp=0x04;																		// 
	
	PORTF=0x00;																				// 
	_StrobE();																				// 
	
	if (ID) temp|=0x02;
	if (S) temp|=0x01;
	PORTF=temp;																				// 
	_StrobE();																				// 
#endif	
}

//===========================      =============================
//  :
//SC -   (0-/1-)
//RL -    (0- /1-  )

void _LED_Display_Shift(uint8_t SC, uint8_t RL)
{
#if	_LED_DATA																				//   (     PORTA4-PORTA7)		
	uint8_t temp=0x00;																		// 
	
	PORTA=0x10;																				// 
	_StrobE();																				// 
	
	if (SC) temp|=0x80;
	if (RL) temp|=0x40;
	PORTA=temp;																				// 
	_StrobE();																				// 
#else																						//   (     PORTF0-PORTF3)	
	uint8_t temp=0x00;																		// 
	
	PORTF=0x01;																				// 
	_StrobE();																				// 
	
	if (SC) temp|=0x08;
	if (RL) temp|=0x04;
	PORTF=temp;																				// 
	_StrobE();																				// 
#endif
}

//=======================      DDRAM =======================
//  :
//Addr -   DDRAM

void _LED_Set_Addres(uint8_t Addr)
{
#if	_LED_DATA																				//   (     PORTA4-PORTA7)		
	uint8_t temp=0x80;																		// 
	
	temp|=Addr;																				//    
	PORTA=temp & 0xF0;																			// 
	_StrobE();																				// 
	
	PORTA=temp<<4;																			// 
	_StrobE();																				// 
#else																						//   (     PORTF0-PORTF3)	
	uint8_t temp=0x80;																		// 
	
	temp|=Addr;																				//    
	PORTF=temp>>4;																			// 
	_StrobE();																				// 
	
	PORTF=temp & 0x0F;																		// 
	_StrobE();																				// 
#endif
}

//================================    =================================
void LED_Clear(void)
{
#if	_LED_DATA																				//   (     PORTA4-PORTA7)		
	PORTA=0x00;																				// 
	_StrobE();																				// 
	PORTA=0x10;																				// 
	_StrobE();																				// 
	_delay_ms(1);
#else																						//   (     PORTF0-PORTF3)	
	PORTF=0x00;																				// 
	_StrobE();																				// 
	PORTF=0x01;																				// 
	_StrobE();																				// 
	_delay_ms(1);
#endif
}

//===========          =============
void LED_Return_Home(void)
{
#if	_LED_DATA																				//   (     PORTA4-PORTA7)		
	PORTA=0x00;																				// 
	_StrobE();																				// 
	PORTA=0x20;																				// 
	_StrobE();																				// 
#else																						//   (     PORTF0-PORTF3)	
	PORTF=0x00;																				// 
	_StrobE();																				// 
	PORTF=0x02;																				// 
	_StrobE();																				// 
#endif
}

//=========================   LED  ===========================
void LED_Init(void)
{
	DDRE|=(1<<PE3)|(1<<PE5)|(1<<PE6);														//  "RS", "R/W"  "E" 
	PORTE|=(1<<PE3)|(1<<PE6);																//   (       H,H->L)
	_delay_ms(10);																			//  
	
	PORTE&=~((1<<PE3)|(1<<PE5)|(1<<PE6));													// 
	
#if	_LED_DATA																				//   (     PORTA4-PORTA7)	
	DDRA|=0xF0;																				//   
#else																						//   (     PORTF0-PORTF3)
	DDRF|=0x0F;																				//   
#endif	
	_delay_ms(10);																			//   	
	
	_LED_Function_Set();																	//  (4  , 2  , 5*8   ,   )
	_LED_Display_Control(1,0,0);															//  ( ,  ,  )
	LED_Clear();																			//  
	LED_Return_Home();																		//    1 
	_LED_Entry_Mode_Set(1,0);																//   ( ,  )
}

//===============          =================
void _LED_Write_Byte(uint8_t Data)
{
	PORTE|=(1<<PE3);																		// "RS"   

#if	_LED_DATA																				//   (     PORTA4-PORTA7)		
	PORTA=Data & 0xF0;																		// 
	_StrobE();																				// 
	PORTA=Data<<4;																			// 
	_StrobE();																				// 
#else																						//   (     PORTF0-PORTF3)
	PORTF=Data>>4;																			// 
	_StrobE();																				// 
	PORTF=Data & 0x0F;																		// 
	_StrobE();																				// 
#endif
	
	PORTE&=~(1<<PE3);																		// "RS"   
}

//====================        ====================
void _LED_Write_Char(uint8_t Data)
{
	PORTE|=(1<<PE3);																		// "RS"   

#if	_LED_DATA																				//   (     PORTA4-PORTA7)		
	PORTA=ASCII[Data] & 0xF0;																// 
	_StrobE();																				// 
	PORTA=ASCII[Data]<<4;																	// 
	_StrobE();																				// 
#else																						//   (     PORTF0-PORTF3)
	PORTF=ASCII[Data]>>4;																	// 
	_StrobE();																				// 
	PORTF=ASCII[Data] & 0x0F;																// 
	_StrobE();																				// 
#endif	
	
	PORTE&=~(1<<PE3);																		// "RS"   
}

//====================        =====================
void LED_Write_String(char *buf)
{
	uint8_t temp;																			// 
	
	for(temp=0; temp<64; temp++)															//    64 ,   
	{
		if(*buf==0) break;																	//     
		_LED_Write_Char(*buf);																//   
		buf++;																				//   
	}
}

//==            =========
void LED_Write_String_P(__flash const char *buf)
{
	uint8_t temp;																			// 
	
	for(temp=0; temp<64; temp++)															//    64 ,   
	{
		if(*buf==0) break;																	//     
		_LED_Write_Char(*buf);																//   
		buf++;																				//   
	}
}

//============================     ===========================
void LED_SetPos(uint8_t Y, uint8_t X)
//  :
//Y -   (0  1)
//X -     ( 0  63)
{
	if (Y>1) return;																		//  
	if (X>63) return;
	
	_LED_Set_Addres((Y<<6)+X);																//   DDRAM   
}

//====================  /   ====================
void LED_CursorEnable(uint8_t EN)
//  :
//EN -    (0- /1-)
{
	if (EN!=0) EN=1;
	_LED_Display_Control(1,EN,0);															//  ( ,  ,  )
}

#ifdef TIMER2																				//  2 
//====================      =======================
void LED_Cycle_Shift(char time)
//  :
//status -      1  (1   50 .   0,   )
{
#ifdef TIMER2
	_LED_Time=time;
	//_Timer2_Enable();																		//    2
#endif
}
#endif

#else
//========================     ==========================
//    :
//Enable -     (1-, 0-).

void Led_Red(char power)
{
	DDRG|=0x08;																				//   
	switch(power)
	{
		case 0:	PORTG|=(1<<PG3); break;														// 
		case 1: PORTG&=~(1<<PG3); break;													// 
		case 2: PORTG^=(1<<PG3);															// 
	}
}
#endif

//============================    ==============================
//    :
//Enable -     (1-, 0-).

void Led(char power)
{
	DDRG|=0x10;																				//   
	switch(power)
	{
	case 0:	PORTG&=0xEF; break;																// 
	case 1: PORTG|=0x10; break;																// 
	case 2: PORTG^=0x10;																	// 
	}
}
#endif